.help-text {
  @extend small;
  @extend .text-muted;
  @extend .form-text;
}

.always-visible-invalid-feedback {
  @extend .invalid-feedback;
  display: block !important;
}

//
// BUTTONS!!! EVERYONE LOVES BUTTONS
//

.btn-mini {
  padding: 0px 4px !important;
  border: none !important;
}

// allow buttons to have 'is-invalid' to show an error
// in the state of the button. It forces the button to appear as
// btn-outline-danger
.btn.is-invalid {
  border-color: var(--danger);
  color: var(--danger);
  &:hover {
    background-color: var(--danger);
    color: white;
  }
}


.btn-toolbar {
  display: flex;
  flex-wrap: wrap;
  gap: 8px;
  &.reverse {
    flex-wrap: wrap-reverse;
  }
  &.right {
    justify-content: flex-end;
  }
  ////margin-top: 2px;
  //margin-left: -8px;
  //.btn,
  //.btn-group,
  //.input-group {
  //  margin-left: 8px;
  //  margin-top: 8px;
  //}
  // useful to make the save button appear last, when really it is first
  .last {
    order: 100;
  }
}

.btn-spacer {
  display: flex;
  .btn,
  .btn-group,
  .input-group {
    margin-left: 8px;
  }
  .last {order: 10;}
}

//.alert .btn-toolbar .btn {
//  margin-bottom: 0px;
//}

//
// when we need buttons to appear as if they are part of the same form
// we use a .button-layout to combine the buttons in multiple forms.
//
.button-layout {
  .btn,
  .btn-group,
  .input-group {
    margin-right: 8px;
    margin-bottom: 8px;
    float: left;
  }
}

//
// by default, bootstrap buttons are wrappable. I don't like this, and I think it always looks bad.
//
.btn {
  white-space: nowrap;
}

// sometimes, we do a nav-tab that is a button
// to make it look right, we need to ensure it has no background.
button.nav-link {
  background-color: transparent;
}
